"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Ipc {
    constructor() {
        this.handlesRunning = 0;
        this.onHandleFinished = () => {
            this.handlesRunning -= 1;
            if (this.handlesRunning === 0 && this.callbackRunOnExhausted) {
                this.callbackRunOnExhausted();
            }
        };
    }
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    sendEnsureDelivered(message) {
        this.handlesRunning += 1;
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        process.send(message, this.onHandleFinished);
    }
    runOnExhausted(cb) {
        if (this.handlesRunning) {
            this.callbackRunOnExhausted = cb;
        }
        else {
            cb();
        }
    }
}
exports.default = Ipc;
//# sourceMappingURL=ipc.js.map