"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable:no-console
function exitLater(code) {
    process.on('exit', function onExit() {
        process.exit(Math.min(code, 255));
    });
}
const exit = (ipc) => (code) => {
    const clampedCode = Math.min(code, 255);
    // that's what mocha does
    console.log('');
    console.error('');
    // wait until all IPC messages are sent to the main process
    ipc.runOnExhausted(() => {
        process.exit(clampedCode);
    });
};
function applyExit(ipc, shouldExitImmediately) {
    return shouldExitImmediately ? exit(ipc) : exitLater;
}
exports.default = applyExit;
//# sourceMappingURL=exit.js.map